//Bei diesem Programm handelt es sich um ein verändertes FFT-Programm
//Quelle: https://github.com/PaulStoffregen/Audio/blob/master/examples/Analysis/FFT/FFT.ino

// FFT Test
//
// Compute a 1024 point Fast Fourier Transform (spectrum analysis)
// on audio connected to the Left Line-In pin.  By changing code,
// a synthetic sine wave can be input instead.
//
// The first 40 (of 512) frequency analysis bins are printed to
// the Arduino Serial Monitor.  Viewing the raw data can help you
// understand how the FFT works and what results to expect when
// using the data to control LEDs, motors, or other fun things!
//
// This example code is in the public domain.
#include <SerialFlash.h>
#include <Audio.h>
#include <Wire.h>
#include <SPI.h>
#include <SD.h>

//#include <ADC.h>
//ADC *adc = new ADC(); // adc object

// Create the Audio components.  These should be created in the
// order data flows, inputs/sources -> processing -> outputs
// Using adafruit mic-amp, edit library to turn-off internal voltage reference in
// inputAnalog.cpp

AudioInputAnalog       adc1(15);
AudioAnalyzeFFT1024    myFFT;


// Connect either the live input or synthesized sine wave
AudioConnection patchCord1(adc1, 0, myFFT, 0);
//AudioConnection patchCord1(sinewave, 0, myFFT, 0);

// for the speaker
/* float phase = 0.0;  //
  float pi = 3.14159; //Periodenlänge
  float val = 0;      //Funktionswert
  float lange = 0.013; //bestimmt Tonhöhe
*/

void setup() {
  // Audio connections require memory to work.  For more
  // detailed information, see the MemoryAndCpuUsage example
  AudioMemory(12);

  pinMode(15, INPUT);
  //analogWriteFrequency(4, 375000); //if frequency function is used...
  analogWriteResolution(12); //for the speaker

  pinMode(20, OUTPUT);

  // Configure the window algorithm to use
  //myFFT.windowFunction(AudioWindowHanning1024);
  myFFT.windowFunction(NULL);

}
const int maxNumWerte = 6;

int freq;      //Frequenz
float fft = 0;    //Fourierwert
float maxfft = 0;   //maximaler Fourierwert

int vorkommensAnzahl;
int frequenzen[maxNumWerte];    //Array, dass Frequenzen beinhaltet
long numbers[maxNumWerte];      //Array, dass Anzahl gleicher Frequenzen beinhaltet
int inDex = 0;                  //Anzahl Frequenzbestimmungen
int inDexFirst = 0;
int freqOld = 0;
int numWerte = 0;               //Tabellenkopf der Arrays
int abspielAnzahl = 0;


void loop() {
  maxfft = 0;


  if (myFFT.available() && numWerte < maxNumWerte && millis() > 5000) { //Startzeit erst nach 5 Sekunden, weil es meistens etwas braucht, bis der Serial-Monitor sichtbar ist
    // each time new FFT data is available
 

    //Schleife, die die ersten 40 FFT-Werte aufruft
    for (int i = 0; i < 40; i++) {
      fft = myFFT.read(i);

      //Bedingung um maximalen FFT-Wert zu bestimmen
      if (fft > maxfft ) {
        maxfft = fft;
        freq = i * 43;
      }
    }

	//Speicherung der gemessenen Frequenzen
    if (freqOld != freq && freq > 300) {           
      vorkommensAnzahl = inDex - inDexFirst;    //Anzahl, wie oft die gleiche Frequenz vorkam
      if (vorkommensAnzahl > 100) {		//nur, wenn dieselbe Frequenz 100 Mal vorkam, wird sie gespeichert

        frequenzen[numWerte] = freqOld;
        numbers[numWerte] = vorkommensAnzahl;
        Serial.print(numWerte);
        Serial.print("\t");
        Serial.print(frequenzen[numWerte]);
        Serial.print("\t");
        Serial.println(numbers[numWerte]);
        numWerte++;
        inDexFirst = inDex;
      }
      freqOld = freq;
    }


    /*Pausen werden nicht aufgenommen, obwohl durch Störgeräusche diese sowieso nur schwer ermittelt werden
      if (freqOld > 0 && freq > 0) {
      if (freqOld != freq) {
        int vorkommensAnzahl = inDex - inDexFirst;
        frequenzen[numWerte] = freqOld;
        numbers[numWerte] = vorkommensAnzahl;
        numWerte++;
        inDexFirst = inDex;
      }
      }
      if (freq > 0) {
      freqOld = freq;
      }
    */

    inDex++;
  }

	//Ausgabe der gespeicherten Tonfrequenzen
  if (numWerte == maxNumWerte) {
    for (int i = 0; i < maxNumWerte-1; i++) {
      abspielAnzahl = numbers[i+1]*3;	//experimentell ermittelter Faktor

      for (int k = 0; k < abspielAnzahl-1; k++) {
        tone(20, frequenzen[i+1]);
      }
    }
  }
}
